; Obsuga klawiatury matrycowej, wizualizacja na linijce LED
; Rafa Baranowski (C) 2004

.INCLUDE "m16def.inc"		; SEGMENT DEKLARACJI

.EQU	SYS_FREQ = 1		; czstotliwo pracy w MHz

.EQU	K_DIODY	= DDRA	; rejestr kierunku portu diod
.EQU	O_DIODY	= PORTA	; rejestr wyjciowy portu diod 

.EQU	K_KLAW	= DDRB	; rejestr kierunku portu klawiatury
.EQU	O_KLAW	= PORTB	; rejestr wyjciowy portu klawiatury
.EQU	I_KLAW	= PINB	; rejestr wejciowy portu klawiatury
.EQU	K_KL_WCISN	= DDRD	; rejestr kierunku linii "kl. wcinity"
.EQU	O_KL_WCISN	= PORTD	; rejestr wyjciowy linii "kl. wcinity"
.EQU	I_KL_WCISN	= PIND	; rejestr wejciowy linii "kl. wcinity"
.EQU	KL_WCISN	= 2		; nr linii dla sygnau "kl. wcinity"



.DSEG				; SEGMENT DANYCH
.ORG	0x0060		; pocztek pamici SRAM
Klaw_inf:	.BYTE	1	; deklaracja zmiennej bajtowej "Klaw_inf" w pamici SRAM



.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	jmp	Reset			; skok do procedury inicjalizujcej

.ORG	INT0addr			; wektor przerwania INT0
	jmp	Odczyt_klawiatury	; skok do procedury odczytujcej stan klawiatury



Reset:				; podprogram inicjalizujcy
	ldi	R17, high(RAMEND)
	ldi	R16, low(RAMEND)
	out	SPH, R17
	out	SPL, R16		; inicjalizacja wskanika stosu

	ldi	R16, 0xFF
	out	K_DIODY, R16	; port diod w trybie wyjciowym

	call	Ini_klawiatury

	clr	R16
	sts	Klaw_inf, R16	; inicjalizacja zmiennej Klaw_inf

	sei				; odblokowanie przerwa


Petla:				; ptla gwna programu	
	lds	R16, Klaw_inf	; odczyt zmiennej adresowanej bezporednio
	out	O_DIODY, R16	; wyprowadzanie wartoci zmiennej opisujcej
					;   stan klawiatury na diodow linijk LED
	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "czekaj_us.inc"	;   oczekiwanie mikrosekundowe
.INCLUDE "klaw_mat.inc"		;   obsuga klawiatury
